using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Drawing;
using Syncfusion.GridExcelConverter;
using System.Diagnostics;
using System.Collections;
using System.Collections.Specialized;

namespace GDBG_2005
{
  public partial class Form1 : Form
  {
    public Form1()
    {
        InitializeComponent();

        this.gridDataBoundGrid1.EnableAddNew = false;

        DataView dv = GetTable().DefaultView;
        this.gridDataBoundGrid1.DataSource = dv;

        this.gridDataBoundGrid1.Model.QueryCellInfo += new GridQueryCellInfoEventHandler(Model_QueryCellInfo);

        StringCollection sc = new StringCollection();
        sc.Add("one");
        sc.Add("Two");
        sc.Add("Three");
        sc.Add("Four");
        this.gridDataBoundGrid1.Binder.InternalColumns[1].StyleInfo.ChoiceList = sc;
        this.gridDataBoundGrid1.Binder.InternalColumns[1].StyleInfo.CellType = "ComboBox";

        this.gridDataBoundGrid1.CurrentCellCloseDropDown += new Syncfusion.Windows.Forms.PopupClosedEventHandler(gridDataBoundGrid1_CurrentCellCloseDropDown);
    }

      void gridDataBoundGrid1_CurrentCellCloseDropDown(object sender, Syncfusion.Windows.Forms.PopupClosedEventArgs e)
      {
          if (e.PopupCloseType == Syncfusion.Windows.Forms.PopupCloseType.Done)
          {
              GridCurrentCell cc = this.gridDataBoundGrid1.CurrentCell;
              hash.Add(GetCodeHash(cc.RowIndex, cc.ColIndex),"SelectedValue");   
          }
      }

      Hashtable hash = new Hashtable();

      private Point  GetCodeHash(int row, int col)
      {
          return new Point(row, col);
      }

      void Model_QueryCellInfo(object sender, GridQueryCellInfoEventArgs e)
      {
          if (e.RowIndex > 0 && e.ColIndex > 0
              && (e.Style.Text == null || e.Style.Text == string.Empty)
              && !hash.Contains(GetCodeHash(e.RowIndex, e.ColIndex)))
          {
              e.Style.Text = e.Style.ChoiceList[0];
          }
      }


    # region * datasource *

    private DataTable GetTable()
    {
      DataTable dt = new DataTable("MyTable");

      int nCols = 10;
      int nRows = 10;
      Random r = new Random();

      for (int i = 0; i < nCols; i++)
      {
        dt.Columns.Add(new DataColumn(string.Format("Col{0}", i)));
      }

      for (int i = 0; i < nRows; ++i)
      {
        DataRow dr = dt.NewRow();
        for (int j = 0; j < nCols; j++)
        {
            if( j != 1 )
                dr[j] = string.Format("row{0} col{1}", i, j);
        }
        dt.Rows.Add(dr);
      }
      return dt;
    }

    # endregion

    private void button1_Click(object sender, EventArgs e)
    {
      Syncfusion.GridExcelConverter.GridExcelConverterControl gecc = new Syncfusion.GridExcelConverter.GridExcelConverterControl();

      SaveFileDialog saveFileDialog = new SaveFileDialog();
      saveFileDialog.Filter = "Files(*.xls)|*.xls";
      saveFileDialog.DefaultExt = ".xls";

      if (saveFileDialog.ShowDialog() == DialogResult.OK)
      {
        gecc.GridToExcel(this.gridDataBoundGrid1.Model, saveFileDialog.FileName,
          Syncfusion.GridExcelConverter.ConverterOptions.RowHeaders);

        if (MessageBox.Show("Do you wish to open the xls file now?", "Export to Excel", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
        {
          Process proc = new Process();
          proc.StartInfo.FileName = saveFileDialog.FileName;
          proc.Start();
        }
      }
    }

  }
}